//DMA Test Program
// Copyright IC-Routing Ltd.
// Author B C O'Neill
//
#include <stdio.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <time.h>

#define TRUE  1
#define FALSE 0
#define TIME_LIMIT 5  // 5 seconds time out

unsigned  dma_no, ch_addr, ch_cnt_addr;
unsigned  irq_no = 3;
int i;

#include "transput.c"
#include "dma.c"



void interrupt (*oldhandler)(void);

char data;
int count = 0, cnt = 0;
char array[1000];
char huge array2[4000];
char array3[8000];
int finito = FALSE;
unsigned long ti, time1;

void init(void)
{
	int  i, state;
	// char ch[1];

	printf("\n\n\nStarting DMA test program:");
	printf("\n");
	printf("\nDMA channel number? Type 0, 1 or 3:");
	printf("\n Choose no. to match hardware switches.  ");
	scanf("%d", &dma_no);
	printf("\n\n DMA test using channel no.  %d  \n\n", dma_no);
	ch_addr 	= DMA_BASE_ADDR + dma_no * 2;
	ch_cnt_addr = DMA_BASE_ADDR + 1 + dma_no * 2;
	outportb(COMMAND_REG, 0x10);  // enable dma controller on PC
	disableDMA();   // disable dma channel
	for (i = 0; i < 4000; i++)
		array2[i] = 66;
	for (i = 0; i < 8000; i++)
		array3[i] = 0;
}

void main(int argc, char *argv[])
{
	int data_read, dma_end;
	int  out;
	char ch, cc;
	register long l;
  clock_t start_time;

	init();
	boot_transputers("grab_dma.btl");
	//boot_transputers(argv[1]);
	// printf("\nError status: %d", inportb(C012_reset) & 1);
	init_B8_DMA(irq_no);
	init_mod_reg_write();



	printf("\nEnter a count and the numbers: ");
	scanf("%d", &count);
	for(i = 0; i < count; i++)
	{
		scanf("%d", &cc);
		array[i] = (unsigned char) cc;
	}
		printf("\nData in: ");
		for(i = 0; i < count; i++)
		printf("%d ", array[i]);


	ch = (char) count;

	load_addr_reg(FP_SEG(array), FP_OFF(array));
	load_count_reg(count);
	//flip_flop();
	//printf("\nCount lo & hi = %d  %d", inportb(ch_cnt_addr),
	//		  inportb(ch_cnt_addr));
	//printf("\n STATUS REG %2x  ", inportb(STATUS_REG));
	WriteLink(&ch, 1);     // send count to transputers
	//printf("\n write count to transputer.");
	start_time = clock();
  dma_end = TRUE;
	enableDMA();
	dma_B8_write_rq();

	// getch();
	// outportb(REQUEST_REG, dma_no + 0x04);

	while(!DMA_complete())
	{
		//flip_flop();
		//getch();
		//printf("\n OSR REG  %x  " , inportb(C012_osr));
		//printf("\nCount lo & hi = %d  %d", inportb(ch_cnt_addr),
		//inportb(ch_cnt_addr));

		if(((clock() - start_time) / CLK_TCK) >= TIME_LIMIT)
		{
    	printf("\nDMA Link output test failed.");
			WriteLink(array, count);     // send data directly to port
      dma_end = FALSE;
			break;
		}
	}
	if(dma_end)
		printf("\nDMA Link output passed test.");
	printf("\nDMA write to port complete. Data sent to transputer.  ");
	// printf("\n ISR REG  %x  " , inportb(C012_isr));

	// printf("\n OSR REG  %x  " , inportb(C012_osr));
	// printf("\n STATUS REG %2x  ", inportb(STATUS_REG));
	// outportb(C012_osr, 0x00);
	//printf("\n STATUS REG %2x  ", inportb(STATUS_REG));
  //disableDMA();
	//getch();
	init_mod_reg_read();
	count = ReadLinkByte();
	printf( "\n\n\n Data from transputer: =  Data in + 7 \n  Count:  %d  \n           ",
				 count);
	//load_addr_reg(FP_SEG(array), FP_OFF(array));
	//load_count_reg(count);
  //enableDMA();
  dma_end = TRUE;
  start_time = clock();
	dma_B8_read_rq();
	l = 0;
	while(!DMA_complete())
	{
		//flip_flop();
		// getch();
		// printf("\n ISR REG  %x  " , inportb(C012_isr));
		// printf("\nCount lo & hi = %d  %d   ", inportb(ch_cnt_addr),
		// 	  inportb(ch_cnt_addr));
		if(((clock() - start_time) / CLK_TCK) >= TIME_LIMIT)
		{
			printf("\nDMA Link input test failed. \n");
			for(i = 0; i < (count-1); i++)
				array[i] = (unsigned char) ReadLinkByte();     // read data directly from port
      dma_end = FALSE;
			break;
		}
	}
  if (dma_end)
     printf("\nDMA Link input passed test.  Data: ");

	for(i = 0; i < count; i++)
		printf("%d ", array[i]);
	disableDMA();
	printf("\nDMA read from port complete. \nEnd of Test.");
	printf("\nPress any key");
	getch();
  if (!dma_end) exit(0);

	WriteLink(&ch, 1);     // send dummy count to transputers
	load_addr_reg(FP_SEG(array2), FP_OFF(array2));
	printf("\nSegment: %X, Offset: %X", FP_SEG(array2), FP_OFF(array2));
	load_count_reg(4000);
	init_mod_reg_write();
	enableDMA();
	dma_B8_write_rq();
	l = 0;
	while(!DMA_complete())
	{
		if(++l == 1000000L)
		{
			printf("\nDMA write link block transfer failed. \n");
			WriteLink(array2, 4000);     // send data directly to port
			break;
		}
	}
	//disableDMA();
	for (i = 0; i < 4000; i++)
		array2[i] = 0;
	init_mod_reg_read();
	//enableDMA();
	dma_B8_read_rq();
	l = 0;
	while(!DMA_complete())
	{
		if(++l == 1000000L)
		{
			printf("\nDMA read link block transfer failed. \n");
			for (i=0; i < 4000; i++)
			array2[i] = ReadLinkByte();     // read data directly to port
			break;
		}
	}
	printf("\nDMA block transfer complete. \n");
	time1 = (unsigned long) ReadLinkByte();
	ti =  (unsigned long) ReadLinkByte();
	time1 = (ti << 8) + time1;
	ti =  (unsigned long) ReadLinkByte();
	time1 = (ti << 16) + time1;
	ti =  (unsigned long) ReadLinkByte();
	time1 = (ti << 24) + time1;
	printf("\nDMA timing for write %lu ", time1);
	time1 = (unsigned long) ReadLinkByte();
	ti =  (unsigned long) ReadLinkByte();
	time1 = (ti << 8) + time1;
	ti =  (unsigned long) ReadLinkByte();
	time1 = (ti << 16) + time1;
	ti =  (unsigned long) ReadLinkByte();
	time1 = (ti << 24) + time1;
	printf("\nDMA timing for read %lu ", time1);
	getch();
}







